#if !defined(__SOCKET__H__)
#define __SOCKET__H__

#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <fcntl.h>
#include <errno.h>
#include <stdio.h>
#include <unistd.h>

//---------------------------------------------------------------------
// This exception is only generated by read/write operations
// Users must check create(), conenct() and accept() systems call 
// with thier return values to catch errors

class QSocketException {
public:
	int handle;
	QSocketException() {}
	QSocketException(int h);
};

//---------------------------------------------------------------------
class QSocket {
	bool exception;
public:
	int handle;

	void setException(bool b) { exception=b; }
// These variables are operation-specific
// When connectiong to client 'targetHost' hold host name
// and 'targetPort' holds target port
// When accepting connection, these variables hold the
// client name and port.
// When acting as server sourcePort variable hold the port to
// which we are bound.
	char targetHost[100];
	int targetPort,sourcePort;

public:
	QSocket();
	bool create(int port,int backlog=5);
	int accept();
	bool connect(char *hostname,int port);
	bool connectSOCKS(char *hostname,int port,char *sockshost,int socksport);
	void close();

	// Read/Write functions - these functions throw
	// QSocketException if socket has been closed.
	int read(void *buffer,int length);
	int write(void *buffer,int length=-1);
	int readline(char *buffer,int length);

	void attach(int h);
	void detach();

	static int connectService(QSocket& s1,QSocket& s2);
	static int connectService(int,int);

};


// Some general socket-related functions

void telnetService(int handle);
int forwardService(bool socks,int handle,char *,int,char *,int);
void socksServer(int handle);
void popService(bool socks,int handle,char *,int);
void socksClientService(int,char*,int);
void programService(int handle,char fields[][256]);
void linAdmin(int handle);
#endif


